#ifndef DOT_H_INCLUDED
#define DOT_H_INCLUDED

#include "coordinates.h"

/* This defines a shape class (subclass of Shape) called Dot that
 * represents a single point.
 */
struct dot;
typedef struct dot Dot;

/* Different types of Dot shape.
 */
enum dot_type {
    DOT_POINT = 0,
    DOT_X = 1,
    DOT_PLUS = 2,
    DOT_CIRCLE = 3,
    DOT_DIAMOND = 4
};

/* Constructor 
 */
extern Shape * dot_new(double dx, double dy);

/* Methods 
 */
extern enum dot_type dot_get_type(const Shape * this);
extern void dot_set_type(Shape * this, enum dot_type t);

extern Coordinates * dot_get_position(Shape * this); 

#endif
