#include <stdio.h>
#include <assert.h>

#include "shape.h"
#include "circle.h"
#include "dot.h"
#include "rectangle.h"
#include "square.h"
#include "polygon.h"

int main() {
    Shape * S[5];
    Coordinates P[] = { { 0,0 }, { 2,4 }, { 4,2 }, { 5,5 }, { 5,-1 } };

    assert(S[0] = dot_new(1,1)); 
    assert(S[1] = circle_new(2,2,3)); 
    assert(S[2] = rectangle_new(10,2,3,4)); 
    assert(S[3] = square_new(0,0,5)); 
    assert(S[4] = polygon_new(P, P + sizeof(P)/sizeof(Coordinates))); 

    Shape * bbox = rectangle_new(0,0,0,0);

    for(int i = 0; i < 5; ++i) {
	shape_print(S[i], stdout);
	fprintf(stdout, " area=%f\n", shape_area(S[i]));
	shape_bounding_rectangle(S[i], bbox);
	fprintf(stdout, "bounding box: ");
	shape_print(bbox, stdout);
    }

    for(int i = 0; i < 5; ++i)
	shape_move(S[i], 2.5*i + 1, 1.5*i + 1);

    for(int i = 0; i < 5; ++i) {
	shape_print(S[i], stdout);
	fprintf(stdout, " area=%f\n", shape_area(S[i]));
    }

    for(int i = 0; i < 5; ++i)
	shape_destroy(S[i]);
}

