#ifndef SHAPE_IMPL_H_INCLUDED
#define SHAPE_IMPL_H_INCLUDED

#include "shape.h"

struct shape_vtable {
    void (*destroy)(Shape * this);
    int (*print)(const Shape * this, FILE * output);
    void (*bounding_rectangle)(const Shape * this, Shape * rectangle);
    double (*area)(const Shape * this);
    void (*move)(Shape * this, double dx, double dy);
};

struct shape {
    struct shape_vtable * vt;
    int id;
};

extern void shape_init(Shape * this, struct shape_vtable * t);
extern double shape_area_impl(const Shape * this);
extern void shape_destroy_impl(Shape * this);

#endif
